# SwaggerClient-php
API for DiscoverSnoop Service

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.9.250210
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/git_user_id/git_repo_id.git"
    }
  ],
  "require": {
    "git_user_id/git_repo_id": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | ID of the alert to edit ; if adding a new one leave blank
$alertname = "alertname_example"; // string | Name of the alert
$activated = true; // bool | Should the alert be activated or not
$type = 56; // int | Alert type (1= New content for website, 2=New performing contents), 3=New contents in category
$channel = 56; // int | 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON
$recipient = "recipient_example"; // string | Email address of recipient or webhook for Slack/Gchat or JSON endpoint
$param1 = "param1_example"; // string | Parameter 1 (meaning changes with alert type)
$param2 = "param2_example"; // string | Parameter 2 (meaning changes with alert type)
$param3 = "param3_example"; // string | Parameter 3 (meaning changes with alert type)
$param4 = "param4_example"; // string | Parameter 4 (meaning changes with alert type)
$param5 = "param5_example"; // string | Parameter 5 (meaning changes with alert type)
$param6 = "param6_example"; // string | Parameter 6 (meaning changes with alert type)

try {
    $result = $apiInstance->alertsChangeGet($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsChangeGet: ', $e->getMessage(), PHP_EOL;
}


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | alert id to delete

try {
    $result = $apiInstance->alertsDeleteGet($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsDeleteGet: ', $e->getMessage(), PHP_EOL;
}


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->alertsGet();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AlertsApi* | [**alertsChangeGet**](docs/Api/AlertsApi.md#alertschangeget) | **GET** /alerts_change | Edit or insert new alert
*AlertsApi* | [**alertsDeleteGet**](docs/Api/AlertsApi.md#alertsdeleteget) | **GET** /alerts_delete | Permanently delete the alert
*AlertsApi* | [**alertsGet**](docs/Api/AlertsApi.md#alertsget) | **GET** /alerts | Get alerts for user account
*FavsApi* | [**favsAddGet**](docs/Api/FavsApi.md#favsaddget) | **GET** /favs_add | Create a new fav
*FavsApi* | [**favsDeleteGet**](docs/Api/FavsApi.md#favsdeleteget) | **GET** /favs_delete | Permanently delete the fav
*FavsApi* | [**favsGet**](docs/Api/FavsApi.md#favsget) | **GET** /favs | Get favorites
*FavsApi* | [**favsUpdateGet**](docs/Api/FavsApi.md#favsupdateget) | **GET** /favs_update | Update the fav
*HistoricalApi* | [**categoriesGet**](docs/Api/HistoricalApi.md#categoriesget) | **GET** /categories | Get historical stats for categories
*HistoricalApi* | [**categoryGet**](docs/Api/HistoricalApi.md#categoryget) | **GET** /category | Get history for category ID
*HistoricalApi* | [**domainGet**](docs/Api/HistoricalApi.md#domainget) | **GET** /domain | Get history for domain name
*HistoricalApi* | [**domainsGet**](docs/Api/HistoricalApi.md#domainsget) | **GET** /domains | Get historical stats for domains
*HistoricalApi* | [**entitiesGet**](docs/Api/HistoricalApi.md#entitiesget) | **GET** /entities | Get historical stats for entities
*HistoricalApi* | [**entityGet**](docs/Api/HistoricalApi.md#entityget) | **GET** /entity | Get history for entity
*HistoricalApi* | [**pageGet**](docs/Api/HistoricalApi.md#pageget) | **GET** /page | Get page history for URL
*HistoricalApi* | [**pagesGet**](docs/Api/HistoricalApi.md#pagesget) | **GET** /pages | Get historical stats for pages
*InfoApi* | [**categoriesListGet**](docs/Api/InfoApi.md#categorieslistget) | **GET** /categories_list | Get list of categories used in the product
*InfoApi* | [**countriesListGet**](docs/Api/InfoApi.md#countrieslistget) | **GET** /countries_list | Get list of countries available in the product
*KbApi* | [**kbArticlesGet**](docs/Api/KbApi.md#kbarticlesget) | **GET** /kb_articles | Get knowledge base articles
*LiveApi* | [**livecategoriesGet**](docs/Api/LiveApi.md#livecategoriesget) | **GET** /livecategories | Get livedata stats for categories
*LiveApi* | [**livedomainsGet**](docs/Api/LiveApi.md#livedomainsget) | **GET** /livedomains | Get livedata stats for domains
*LiveApi* | [**liveentitiesGet**](docs/Api/LiveApi.md#liveentitiesget) | **GET** /liveentities | Get livedata stats for entities
*LiveApi* | [**livepagesGet**](docs/Api/LiveApi.md#livepagesget) | **GET** /livepages | Get livedata stats for pages
*UserApi* | [**userCountriesChangeGet**](docs/Api/UserApi.md#usercountrieschangeget) | **GET** /user_countries_change | Change user&#x27;s activated countries
*UserApi* | [**userCustidChangeGet**](docs/Api/UserApi.md#usercustidchangeget) | **GET** /user_custid_change | Change user customer id. This function is system reserved
*UserApi* | [**userDeleteGet**](docs/Api/UserApi.md#userdeleteget) | **GET** /user_delete | Permanently delete the user
*UserApi* | [**userDetailsChangeGet**](docs/Api/UserApi.md#userdetailschangeget) | **GET** /user_details_change | Change user details
*UserApi* | [**userLoginGet**](docs/Api/UserApi.md#userloginget) | **GET** /user_login | Login user with his credentials
*UserApi* | [**userMessagesGet**](docs/Api/UserApi.md#usermessagesget) | **GET** /user_messages | Get messages for user
*UserApi* | [**userPasswordChangeGet**](docs/Api/UserApi.md#userpasswordchangeget) | **GET** /user_password_change | Change user password
*UserApi* | [**userPasswordResetGet**](docs/Api/UserApi.md#userpasswordresetget) | **GET** /user_password_reset | Reset user password
*UserApi* | [**userRefreshSubscriptionGet**](docs/Api/UserApi.md#userrefreshsubscriptionget) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*UserApi* | [**userRegisterGet**](docs/Api/UserApi.md#userregisterget) | **GET** /user_register | Login user with his credentials

## Documentation For Models

 - [AlertCollection](docs/Model/AlertCollection.md)
 - [Alerts](docs/Model/Alerts.md)
 - [Categories](docs/Model/Categories.md)
 - [CategoriesCollection](docs/Model/CategoriesCollection.md)
 - [CategoriesList](docs/Model/CategoriesList.md)
 - [CategoriesListCollection](docs/Model/CategoriesListCollection.md)
 - [Category](docs/Model/Category.md)
 - [CountriesList](docs/Model/CountriesList.md)
 - [CountriesListCollection](docs/Model/CountriesListCollection.md)
 - [DistributionCollection](docs/Model/DistributionCollection.md)
 - [Domain](docs/Model/Domain.md)
 - [Domains](docs/Model/Domains.md)
 - [DomainsCollection](docs/Model/DomainsCollection.md)
 - [Entities](docs/Model/Entities.md)
 - [EntitiesCollection](docs/Model/EntitiesCollection.md)
 - [Entity](docs/Model/Entity.md)
 - [Favs](docs/Model/Favs.md)
 - [FavsCollection](docs/Model/FavsCollection.md)
 - [KB](docs/Model/KB.md)
 - [KBCollection](docs/Model/KBCollection.md)
 - [Message](docs/Model/Message.md)
 - [MessageCollection](docs/Model/MessageCollection.md)
 - [MetricsCollection](docs/Model/MetricsCollection.md)
 - [Page](docs/Model/Page.md)
 - [Pages](docs/Model/Pages.md)
 - [PagesCollection](docs/Model/PagesCollection.md)
 - [TransactionInfo](docs/Model/TransactionInfo.md)
 - [UserCollection](docs/Model/UserCollection.md)
 - [UserInfo](docs/Model/UserInfo.md)

## Documentation For Authorization


## bearerAuth

- **Type**: HTTP bearer authentication


## Author



