# Swagger\Client\AlertsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**alertsChangeGet**](AlertsApi.md#alertschangeget) | **GET** /alerts_change | Edit or insert new alert
[**alertsDeleteGet**](AlertsApi.md#alertsdeleteget) | **GET** /alerts_delete | Permanently delete the alert
[**alertsGet**](AlertsApi.md#alertsget) | **GET** /alerts | Get alerts for user account

# **alertsChangeGet**
> \Swagger\Client\Model\Domains[] alertsChangeGet($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6)

Edit or insert new alert

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | ID of the alert to edit ; if adding a new one leave blank
$alertname = "alertname_example"; // string | Name of the alert
$activated = true; // bool | Should the alert be activated or not
$type = 56; // int | Alert type (1= New content for website, 2=New performing contents), 3=New contents in category
$channel = 56; // int | 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON
$recipient = "recipient_example"; // string | Email address of recipient or webhook for Slack/Gchat or JSON endpoint
$param1 = "param1_example"; // string | Parameter 1 (meaning changes with alert type)
$param2 = "param2_example"; // string | Parameter 2 (meaning changes with alert type)
$param3 = "param3_example"; // string | Parameter 3 (meaning changes with alert type)
$param4 = "param4_example"; // string | Parameter 4 (meaning changes with alert type)
$param5 = "param5_example"; // string | Parameter 5 (meaning changes with alert type)
$param6 = "param6_example"; // string | Parameter 6 (meaning changes with alert type)

try {
    $result = $apiInstance->alertsChangeGet($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsChangeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| ID of the alert to edit ; if adding a new one leave blank |
 **alertname** | **string**| Name of the alert |
 **activated** | **bool**| Should the alert be activated or not |
 **type** | **int**| Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category |
 **channel** | **int**| 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON |
 **recipient** | **string**| Email address of recipient or webhook for Slack/Gchat or JSON endpoint |
 **param1** | **string**| Parameter 1 (meaning changes with alert type) | [optional]
 **param2** | **string**| Parameter 2 (meaning changes with alert type) | [optional]
 **param3** | **string**| Parameter 3 (meaning changes with alert type) | [optional]
 **param4** | **string**| Parameter 4 (meaning changes with alert type) | [optional]
 **param5** | **string**| Parameter 5 (meaning changes with alert type) | [optional]
 **param6** | **string**| Parameter 6 (meaning changes with alert type) | [optional]

### Return type

[**\Swagger\Client\Model\Domains[]**](../Model/Domains.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **alertsDeleteGet**
> \Swagger\Client\Model\TransactionInfo[] alertsDeleteGet($id)

Permanently delete the alert

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | alert id to delete

try {
    $result = $apiInstance->alertsDeleteGet($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsDeleteGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| alert id to delete |

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **alertsGet**
> \Swagger\Client\Model\Alerts[] alertsGet()

Get alerts for user account

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\AlertsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->alertsGet();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AlertsApi->alertsGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Swagger\Client\Model\Alerts[]**](../Model/Alerts.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

