# Swagger\Client\FavsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**favsAddGet**](FavsApi.md#favsaddget) | **GET** /favs_add | Create a new fav
[**favsDeleteGet**](FavsApi.md#favsdeleteget) | **GET** /favs_delete | Permanently delete the fav
[**favsGet**](FavsApi.md#favsget) | **GET** /favs | Get favorites
[**favsUpdateGet**](FavsApi.md#favsupdateget) | **GET** /favs_update | Update the fav

# **favsAddGet**
> \Swagger\Client\Model\TransactionInfo[] favsAddGet($name, $action, $parameters)

Create a new fav

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\FavsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$name = "name_example"; // string | Name of the fav.
$action = "action_example"; // string | Action to be opened.
$parameters = "parameters_example"; // string | Action's parameters encoded in JSON.

try {
    $result = $apiInstance->favsAddGet($name, $action, $parameters);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling FavsApi->favsAddGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**| Name of the fav. | [optional]
 **action** | **string**| Action to be opened. | [optional]
 **parameters** | **string**| Action&#x27;s parameters encoded in JSON. | [optional]

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **favsDeleteGet**
> \Swagger\Client\Model\TransactionInfo[] favsDeleteGet($id)

Permanently delete the fav

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\FavsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | ID of the fav to delete.

try {
    $result = $apiInstance->favsDeleteGet($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling FavsApi->favsDeleteGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| ID of the fav to delete. | [optional]

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **favsGet**
> \Swagger\Client\Model\Favs[] favsGet($id)

Get favorites

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\FavsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | ID of the requested fav. ignore or set to 0 to get the full favs list

try {
    $result = $apiInstance->favsGet($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling FavsApi->favsGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| ID of the requested fav. ignore or set to 0 to get the full favs list | [optional]

### Return type

[**\Swagger\Client\Model\Favs[]**](../Model/Favs.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **favsUpdateGet**
> \Swagger\Client\Model\TransactionInfo[] favsUpdateGet($id, $name, $action, $parameters, $scheduled, $scheduledto)

Update the fav

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\FavsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | ID of the fav that should be edited
$name = "name_example"; // string | Name of the fav.
$action = "action_example"; // string | Action to be opened.
$parameters = "parameters_example"; // string | Action's parameters encoded in JSON.
$scheduled = 56; // int | 0 if not scheduled, else x in hours
$scheduledto = "scheduledto_example"; // string | email address of the recipient of this report

try {
    $result = $apiInstance->favsUpdateGet($id, $name, $action, $parameters, $scheduled, $scheduledto);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling FavsApi->favsUpdateGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| ID of the fav that should be edited |
 **name** | **string**| Name of the fav. | [optional]
 **action** | **string**| Action to be opened. | [optional]
 **parameters** | **string**| Action&#x27;s parameters encoded in JSON. | [optional]
 **scheduled** | **int**| 0 if not scheduled, else x in hours | [optional]
 **scheduledto** | **string**| email address of the recipient of this report | [optional]

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

