# Swagger\Client\HistoricalApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**categoriesGet**](HistoricalApi.md#categoriesget) | **GET** /categories | Get historical stats for categories
[**categoryGet**](HistoricalApi.md#categoryget) | **GET** /category | Get history for category ID
[**domainGet**](HistoricalApi.md#domainget) | **GET** /domain | Get history for domain name
[**domainsGet**](HistoricalApi.md#domainsget) | **GET** /domains | Get historical stats for domains
[**entitiesGet**](HistoricalApi.md#entitiesget) | **GET** /entities | Get historical stats for entities
[**entityGet**](HistoricalApi.md#entityget) | **GET** /entity | Get history for entity
[**pageGet**](HistoricalApi.md#pageget) | **GET** /page | Get page history for URL
[**pagesGet**](HistoricalApi.md#pagesget) | **GET** /pages | Get historical stats for pages

# **categoriesGet**
> \Swagger\Client\Model\Categories[] categoriesGet($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset)

Get historical stats for categories

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
$keyword_filter = "keyword_filter_example"; // string | Filter answers to cateogry names containing a particular keyword
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->categoriesGet($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->categoriesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **keyword_filter** | **string**| Filter answers to cateogry names containing a particular keyword | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Categories[]**](../Model/Categories.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **categoryGet**
> \Swagger\Client\Model\Category[] categoryGet($id, $country, $subcountry, $from_date, $to_date)

Get history for category ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | category id
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)

try {
    $result = $apiInstance->categoryGet($id, $country, $subcountry, $from_date, $to_date);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->categoryGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| category id |
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]

### Return type

[**\Swagger\Client\Model\Category[]**](../Model/Category.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **domainGet**
> \Swagger\Client\Model\Domain[] domainGet($domain, $country, $subcountry, $from_date, $to_date)

Get history for domain name

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$domain = "domain_example"; // string | domain name (no subdomain allowed)
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)

try {
    $result = $apiInstance->domainGet($domain, $country, $subcountry, $from_date, $to_date);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->domainGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain** | **string**| domain name (no subdomain allowed) |
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]

### Return type

[**\Swagger\Client\Model\Domain[]**](../Model/Domain.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **domainsGet**
> \Swagger\Client\Model\Domains[] domainsGet($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset)

Get historical stats for domains

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
$url_filter = "url_filter_example"; // string | Filter answers to domains including a specified string
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->domainsGet($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->domainsGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **url_filter** | **string**| Filter answers to domains including a specified string | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Domains[]**](../Model/Domains.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **entitiesGet**
> \Swagger\Client\Model\Entities[] entitiesGet($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset)

Get historical stats for entities

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)
$keyword_filter = "keyword_filter_example"; // string | Filter answers to entity names containing a particular keyword
$lines = 50; // int | Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->entitiesGet($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->entitiesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **keyword_filter** | **string**| Filter answers to entity names containing a particular keyword | [optional]
 **lines** | **int**| Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Entities[]**](../Model/Entities.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **entityGet**
> \Swagger\Client\Model\Entity[] entityGet($name, $country, $subcountry, $from_date, $to_date)

Get history for entity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$name = "name_example"; // string | entity exact name URL encoded
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)

try {
    $result = $apiInstance->entityGet($name, $country, $subcountry, $from_date, $to_date);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->entityGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**| entity exact name URL encoded |
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]

### Return type

[**\Swagger\Client\Model\Entity[]**](../Model/Entity.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **pageGet**
> \Swagger\Client\Model\Page[] pageGet($url, $country, $subcountry, $from_date, $to_date)

Get page history for URL

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$url = "url_example"; // string | Fully qualified page url. URL needs to be URL encoded
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience)

try {
    $result = $apiInstance->pageGet($url, $country, $subcountry, $from_date, $to_date);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->pageGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **url** | **string**| Fully qualified page url. URL needs to be URL encoded |
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) | [optional]

### Return type

[**\Swagger\Client\Model\Page[]**](../Model/Page.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **pagesGet**
> \Swagger\Client\Model\Pages[] pagesGet($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset)

Get historical stats for pages

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\HistoricalApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$from_date = "from_date_example"; // string | Datas from YYYY-MM-DD (if not provided, last 30 days)
$to_date = "to_date_example"; // string | Datas to YYYY-MM-DD (if not provided, last 30 days)
$country = "country_example"; // string | ISO_3166 country code in 2 letters (if not provided  worldwide)
$subcountry = "subcountry_example"; // string | state code
$preset_filter = 56; // int | Apply preset filters => 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories
$domain_filter = "domain_filter_example"; // string | Filter answers to pages of a designated domain name
$keyword_filter = "keyword_filter_example"; // string | Filter answers to pages titles containing a particular keyword
$entity_filter = "entity_filter_example"; // string | Filter answers to pages with entities containing a particular keyword
$url_filter = "url_filter_example"; // string | Filter answers to pages URL including a specified string
$category_filter = 56; // int | Filter answers to a specific page category
$language_filter = "language_filter_example"; // string | Filter answers to pages in specific user language
$lines = 50; // int | Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->pagesGet($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling HistoricalApi->pagesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **from_date** | **string**| Datas from YYYY-MM-DD (if not provided, last 30 days) | [optional]
 **to_date** | **string**| Datas to YYYY-MM-DD (if not provided, last 30 days) | [optional]
 **country** | **string**| ISO_3166 country code in 2 letters (if not provided  worldwide) | [optional]
 **subcountry** | **string**| state code | [optional]
 **preset_filter** | **int**| Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories | [optional]
 **domain_filter** | **string**| Filter answers to pages of a designated domain name | [optional]
 **keyword_filter** | **string**| Filter answers to pages titles containing a particular keyword | [optional]
 **entity_filter** | **string**| Filter answers to pages with entities containing a particular keyword | [optional]
 **url_filter** | **string**| Filter answers to pages URL including a specified string | [optional]
 **category_filter** | **int**| Filter answers to a specific page category | [optional]
 **language_filter** | **string**| Filter answers to pages in specific user language | [optional]
 **lines** | **int**| Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Pages[]**](../Model/Pages.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

