# Swagger\Client\KbApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**kbArticlesGet**](KbApi.md#kbarticlesget) | **GET** /kb_articles | Get knowledge base articles

# **kbArticlesGet**
> \Swagger\Client\Model\KB[] kbArticlesGet($article)

Get knowledge base articles

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\KbApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$article = 56; // int | ID of the requested article. 0 to get the full article list

try {
    $result = $apiInstance->kbArticlesGet($article);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling KbApi->kbArticlesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **article** | **int**| ID of the requested article. 0 to get the full article list | [optional]

### Return type

[**\Swagger\Client\Model\KB[]**](../Model/KB.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

