# Swagger\Client\LiveApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**livecategoriesGet**](LiveApi.md#livecategoriesget) | **GET** /livecategories | Get livedata stats for categories
[**livedomainsGet**](LiveApi.md#livedomainsget) | **GET** /livedomains | Get livedata stats for domains
[**liveentitiesGet**](LiveApi.md#liveentitiesget) | **GET** /liveentities | Get livedata stats for entities
[**livepagesGet**](LiveApi.md#livepagesget) | **GET** /livepages | Get livedata stats for pages

# **livecategoriesGet**
> \Swagger\Client\Model\Categories[] livecategoriesGet($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset)

Get livedata stats for categories

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\LiveApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$hours = 56; // int | Get results for last x hours
$keyword_filter = "keyword_filter_example"; // string | Filter answers to category names containing a particular keyword
$language_filter = "language_filter_example"; // string | Filter answers to pages in specific user language
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->livecategoriesGet($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LiveApi->livecategoriesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **hours** | **int**| Get results for last x hours | [optional]
 **keyword_filter** | **string**| Filter answers to category names containing a particular keyword | [optional]
 **language_filter** | **string**| Filter answers to pages in specific user language | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Categories[]**](../Model/Categories.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **livedomainsGet**
> \Swagger\Client\Model\Domains[] livedomainsGet($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset)

Get livedata stats for domains

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\LiveApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$url_filter = "url_filter_example"; // string | Filter answers to domains including a specified string
$hours = 56; // int | Get results for last x hours
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
$language_filter = "language_filter_example"; // string | Filter answers to pages in specific user language
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->livedomainsGet($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LiveApi->livedomainsGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **url_filter** | **string**| Filter answers to domains including a specified string | [optional]
 **hours** | **int**| Get results for last x hours | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **language_filter** | **string**| Filter answers to pages in specific user language | [optional]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Domains[]**](../Model/Domains.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **liveentitiesGet**
> \Swagger\Client\Model\Entities[] liveentitiesGet($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset)

Get livedata stats for entities

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\LiveApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$hours = 56; // int | Get results for last x hours
$keyword_filter = "keyword_filter_example"; // string | Filter answers to entity names containing a particular keyword
$category_filter = 56; // int | Filter answers to pages of a designated category id
$language_filter = "language_filter_example"; // string | Filter answers to pages in specific user language
$domain_filter = "domain_filter_example"; // string | Filter answers to pages of a designated domain name
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->liveentitiesGet($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LiveApi->liveentitiesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **hours** | **int**| Get results for last x hours | [optional]
 **keyword_filter** | **string**| Filter answers to entity names containing a particular keyword | [optional]
 **category_filter** | **int**| Filter answers to pages of a designated category id | [optional]
 **language_filter** | **string**| Filter answers to pages in specific user language | [optional]
 **domain_filter** | **string**| Filter answers to pages of a designated domain name | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Entities[]**](../Model/Entities.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **livepagesGet**
> \Swagger\Client\Model\Pages[] livepagesGet($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset)

Get livedata stats for pages

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\LiveApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$country = "country_example"; // string | ISO_3166 country code in 2 letters
$subcountry = "subcountry_example"; // string | state code
$hours = 56; // int | Get results for last x hours
$preset_filter = 56; // int | Apply preset filters => 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories
$only_new = 0; // int | Get only pages first seen in the reporting period if set on 1
$domain_filter = "domain_filter_example"; // string | Filter answers to pages of a designated domain name
$keyword_filter = "keyword_filter_example"; // string | Filter answers to pages titles containing a particular keyword
$entity_filter = "entity_filter_example"; // string | Filter answers to pages with entities containing a particular keyword
$url_filter = "url_filter_example"; // string | Filter answers to pages URL including a specified string
$category_filter = 56; // int | Filter answers to pages of a designated category id
$language_filter = "language_filter_example"; // string | Filter answers to pages in specific user language
$lines = 50; // int | Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more)
$offset = 0; // int | Get paginated results from X offset

try {
    $result = $apiInstance->livepagesGet($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LiveApi->livepagesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| ISO_3166 country code in 2 letters |
 **subcountry** | **string**| state code | [optional]
 **hours** | **int**| Get results for last x hours | [optional]
 **preset_filter** | **int**| Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories | [optional]
 **only_new** | **int**| Get only pages first seen in the reporting period if set on 1 | [optional] [default to 0]
 **domain_filter** | **string**| Filter answers to pages of a designated domain name | [optional]
 **keyword_filter** | **string**| Filter answers to pages titles containing a particular keyword | [optional]
 **entity_filter** | **string**| Filter answers to pages with entities containing a particular keyword | [optional]
 **url_filter** | **string**| Filter answers to pages URL including a specified string | [optional]
 **category_filter** | **int**| Filter answers to pages of a designated category id | [optional]
 **language_filter** | **string**| Filter answers to pages in specific user language | [optional]
 **lines** | **int**| Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) | [optional] [default to 50]
 **offset** | **int**| Get paginated results from X offset | [optional] [default to 0]

### Return type

[**\Swagger\Client\Model\Pages[]**](../Model/Pages.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

