# Swagger\Client\UserApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userCountriesChangeGet**](UserApi.md#usercountrieschangeget) | **GET** /user_countries_change | Change user&#x27;s activated countries
[**userCustidChangeGet**](UserApi.md#usercustidchangeget) | **GET** /user_custid_change | Change user customer id. This function is system reserved
[**userDeleteGet**](UserApi.md#userdeleteget) | **GET** /user_delete | Permanently delete the user
[**userDetailsChangeGet**](UserApi.md#userdetailschangeget) | **GET** /user_details_change | Change user details
[**userLoginGet**](UserApi.md#userloginget) | **GET** /user_login | Login user with his credentials
[**userMessagesGet**](UserApi.md#usermessagesget) | **GET** /user_messages | Get messages for user
[**userPasswordChangeGet**](UserApi.md#userpasswordchangeget) | **GET** /user_password_change | Change user password
[**userPasswordResetGet**](UserApi.md#userpasswordresetget) | **GET** /user_password_reset | Reset user password
[**userRefreshSubscriptionGet**](UserApi.md#userrefreshsubscriptionget) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
[**userRegisterGet**](UserApi.md#userregisterget) | **GET** /user_register | Login user with his credentials

# **userCountriesChangeGet**
> \Swagger\Client\Model\TransactionInfo[] userCountriesChangeGet($countries, $categories)

Change user's activated countries

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$countries = "countries_example"; // string | json encoded string representing countries to activate
$categories = "categories_example"; // string | json encoded string representing categories ID to activate

try {
    $result = $apiInstance->userCountriesChangeGet($countries, $categories);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userCountriesChangeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **countries** | **string**| json encoded string representing countries to activate |
 **categories** | **string**| json encoded string representing categories ID to activate |

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userCustidChangeGet**
> \Swagger\Client\Model\TransactionInfo[] userCustidChangeGet($custid)

Change user customer id. This function is system reserved

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$custid = "custid_example"; // string | new customer id for user

try {
    $result = $apiInstance->userCustidChangeGet($custid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userCustidChangeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **string**| new customer id for user |

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userDeleteGet**
> \Swagger\Client\Model\TransactionInfo[] userDeleteGet()

Permanently delete the user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->userDeleteGet();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userDeleteGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userDetailsChangeGet**
> \Swagger\Client\Model\TransactionInfo[] userDetailsChangeGet($email, $fname, $lname, $translation)

Change user details

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$email = "email_example"; // string | new email address for user
$fname = "fname_example"; // string | new firstname for user
$lname = "lname_example"; // string | new lastname for user
$translation = "translation_example"; // string | update the translation settings for user original (will show original titles) | english (will show titles translated in english)

try {
    $result = $apiInstance->userDetailsChangeGet($email, $fname, $lname, $translation);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userDetailsChangeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **string**| new email address for user |
 **fname** | **string**| new firstname for user |
 **lname** | **string**| new lastname for user |
 **translation** | **string**| update the translation settings for user original (will show original titles) | english (will show titles translated in english) | [optional]

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userLoginGet**
> \Swagger\Client\Model\UserInfo[] userLoginGet($email, $password, $pin)

Login user with his credentials

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$email = "email_example"; // string | email address for user
$password = "password_example"; // string | password for user
$pin = 56; // int | pin code to validate account creation ; when using pin code, password must be set to \"loginwithpin\"

try {
    $result = $apiInstance->userLoginGet($email, $password, $pin);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userLoginGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **string**| email address for user |
 **password** | **string**| password for user |
 **pin** | **int**| pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; | [optional]

### Return type

[**\Swagger\Client\Model\UserInfo[]**](../Model/UserInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userMessagesGet**
> \Swagger\Client\Model\Message[] userMessagesGet($message)

Get messages for user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$message = 56; // int | ID of the requested message. 0 to get the full message list

try {
    $result = $apiInstance->userMessagesGet($message);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userMessagesGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | **int**| ID of the requested message. 0 to get the full message list | [optional]

### Return type

[**\Swagger\Client\Model\Message[]**](../Model/Message.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userPasswordChangeGet**
> \Swagger\Client\Model\TransactionInfo[] userPasswordChangeGet($email, $password, $newpassword)

Change user password

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$email = "email_example"; // string | email address for user
$password = "password_example"; // string | current password for user
$newpassword = "newpassword_example"; // string | new password to set up for user

try {
    $result = $apiInstance->userPasswordChangeGet($email, $password, $newpassword);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userPasswordChangeGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **string**| email address for user |
 **password** | **string**| current password for user |
 **newpassword** | **string**| new password to set up for user |

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userPasswordResetGet**
> \Swagger\Client\Model\TransactionInfo[] userPasswordResetGet($email)

Reset user password

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$email = "email_example"; // string | email address for user

try {
    $result = $apiInstance->userPasswordResetGet($email);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userPasswordResetGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **string**| email address for user |

### Return type

[**\Swagger\Client\Model\TransactionInfo[]**](../Model/TransactionInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userRefreshSubscriptionGet**
> \Swagger\Client\Model\UserInfo[] userRefreshSubscriptionGet($custid)

Refresh user rights with his Customer ID. This function is system reserved

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$custid = "custid_example"; // string | Customer ID for the user

try {
    $result = $apiInstance->userRefreshSubscriptionGet($custid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userRefreshSubscriptionGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **string**| Customer ID for the user |

### Return type

[**\Swagger\Client\Model\UserInfo[]**](../Model/UserInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userRegisterGet**
> \Swagger\Client\Model\UserInfo[] userRegisterGet($email, $password, $fname, $lname, $referrer)

Login user with his credentials

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
    // Configure HTTP bearer authorization: bearerAuth
    $config = Swagger\Client\Configuration::getDefaultConfiguration()
    ->setAccessToken('YOUR_ACCESS_TOKEN');


$apiInstance = new Swagger\Client\Api\UserApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$email = "email_example"; // string | email address for user
$password = "password_example"; // string | password for user
$fname = "fname_example"; // string | new firstname for user
$lname = "lname_example"; // string | new lastname for user
$referrer = "referrer_example"; // string | referrer for this user. should be urlencoded

try {
    $result = $apiInstance->userRegisterGet($email, $password, $fname, $lname, $referrer);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UserApi->userRegisterGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **string**| email address for user |
 **password** | **string**| password for user |
 **fname** | **string**| new firstname for user |
 **lname** | **string**| new lastname for user |
 **referrer** | **string**| referrer for this user. should be urlencoded | [optional]

### Return type

[**\Swagger\Client\Model\UserInfo[]**](../Model/UserInfo.md)

### Authorization

[bearerAuth](../../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

