<?php
/**
 * AlertsApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.67
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * AlertsApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AlertsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation alertsChangeGet
     *
     * Edit or insert new alert
     *
     * @param  string $id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param  string $alertname Name of the alert (required)
     * @param  bool $activated Should the alert be activated or not (required)
     * @param  int $type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category (required)
     * @param  int $channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON (required)
     * @param  string $recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint (required)
     * @param  string $param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param  string $param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param  string $param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param  string $param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param  string $param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param  string $param6 Parameter 6 (meaning changes with alert type) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Domains[]
     */
    public function alertsChangeGet($id, $alertname, $activated, $type, $channel, $recipient, $param1 = null, $param2 = null, $param3 = null, $param4 = null, $param5 = null, $param6 = null)
    {
        list($response) = $this->alertsChangeGetWithHttpInfo($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6);
        return $response;
    }

    /**
     * Operation alertsChangeGetWithHttpInfo
     *
     * Edit or insert new alert
     *
     * @param  string $id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param  string $alertname Name of the alert (required)
     * @param  bool $activated Should the alert be activated or not (required)
     * @param  int $type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category (required)
     * @param  int $channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON (required)
     * @param  string $recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint (required)
     * @param  string $param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param  string $param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param  string $param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param  string $param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param  string $param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param  string $param6 Parameter 6 (meaning changes with alert type) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Domains[], HTTP status code, HTTP response headers (array of strings)
     */
    public function alertsChangeGetWithHttpInfo($id, $alertname, $activated, $type, $channel, $recipient, $param1 = null, $param2 = null, $param3 = null, $param4 = null, $param5 = null, $param6 = null)
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->alertsChangeGetRequest($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Domains[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation alertsChangeGetAsync
     *
     * Edit or insert new alert
     *
     * @param  string $id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param  string $alertname Name of the alert (required)
     * @param  bool $activated Should the alert be activated or not (required)
     * @param  int $type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category (required)
     * @param  int $channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON (required)
     * @param  string $recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint (required)
     * @param  string $param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param  string $param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param  string $param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param  string $param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param  string $param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param  string $param6 Parameter 6 (meaning changes with alert type) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsChangeGetAsync($id, $alertname, $activated, $type, $channel, $recipient, $param1 = null, $param2 = null, $param3 = null, $param4 = null, $param5 = null, $param6 = null)
    {
        return $this->alertsChangeGetAsyncWithHttpInfo($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation alertsChangeGetAsyncWithHttpInfo
     *
     * Edit or insert new alert
     *
     * @param  string $id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param  string $alertname Name of the alert (required)
     * @param  bool $activated Should the alert be activated or not (required)
     * @param  int $type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category (required)
     * @param  int $channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON (required)
     * @param  string $recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint (required)
     * @param  string $param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param  string $param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param  string $param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param  string $param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param  string $param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param  string $param6 Parameter 6 (meaning changes with alert type) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsChangeGetAsyncWithHttpInfo($id, $alertname, $activated, $type, $channel, $recipient, $param1 = null, $param2 = null, $param3 = null, $param4 = null, $param5 = null, $param6 = null)
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->alertsChangeGetRequest($id, $alertname, $activated, $type, $channel, $recipient, $param1, $param2, $param3, $param4, $param5, $param6);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'alertsChangeGet'
     *
     * @param  string $id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param  string $alertname Name of the alert (required)
     * @param  bool $activated Should the alert be activated or not (required)
     * @param  int $type Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category (required)
     * @param  int $channel 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON (required)
     * @param  string $recipient Email address of recipient or webhook for Slack/Gchat or JSON endpoint (required)
     * @param  string $param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param  string $param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param  string $param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param  string $param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param  string $param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param  string $param6 Parameter 6 (meaning changes with alert type) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function alertsChangeGetRequest($id, $alertname, $activated, $type, $channel, $recipient, $param1 = null, $param2 = null, $param3 = null, $param4 = null, $param5 = null, $param6 = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling alertsChangeGet'
            );
        }
        // verify the required parameter 'alertname' is set
        if ($alertname === null || (is_array($alertname) && count($alertname) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $alertname when calling alertsChangeGet'
            );
        }
        // verify the required parameter 'activated' is set
        if ($activated === null || (is_array($activated) && count($activated) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $activated when calling alertsChangeGet'
            );
        }
        // verify the required parameter 'type' is set
        if ($type === null || (is_array($type) && count($type) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $type when calling alertsChangeGet'
            );
        }
        // verify the required parameter 'channel' is set
        if ($channel === null || (is_array($channel) && count($channel) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $channel when calling alertsChangeGet'
            );
        }
        // verify the required parameter 'recipient' is set
        if ($recipient === null || (is_array($recipient) && count($recipient) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $recipient when calling alertsChangeGet'
            );
        }

        $resourcePath = '/alerts_change';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($id !== null) {
            $queryParams['id'] = ObjectSerializer::toQueryValue($id, null);
        }
        // query params
        if ($alertname !== null) {
            $queryParams['alertname'] = ObjectSerializer::toQueryValue($alertname, null);
        }
        // query params
        if ($activated !== null) {
            $queryParams['activated'] = ObjectSerializer::toQueryValue($activated, null);
        }
        // query params
        if ($type !== null) {
            $queryParams['type'] = ObjectSerializer::toQueryValue($type, null);
        }
        // query params
        if ($channel !== null) {
            $queryParams['channel'] = ObjectSerializer::toQueryValue($channel, null);
        }
        // query params
        if ($recipient !== null) {
            $queryParams['recipient'] = ObjectSerializer::toQueryValue($recipient, null);
        }
        // query params
        if ($param1 !== null) {
            $queryParams['param1'] = ObjectSerializer::toQueryValue($param1, null);
        }
        // query params
        if ($param2 !== null) {
            $queryParams['param2'] = ObjectSerializer::toQueryValue($param2, null);
        }
        // query params
        if ($param3 !== null) {
            $queryParams['param3'] = ObjectSerializer::toQueryValue($param3, null);
        }
        // query params
        if ($param4 !== null) {
            $queryParams['param4'] = ObjectSerializer::toQueryValue($param4, null);
        }
        // query params
        if ($param5 !== null) {
            $queryParams['param5'] = ObjectSerializer::toQueryValue($param5, null);
        }
        // query params
        if ($param6 !== null) {
            $queryParams['param6'] = ObjectSerializer::toQueryValue($param6, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation alertsDeleteGet
     *
     * Permanently delete the alert
     *
     * @param  string $id alert id to delete (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\TransactionInfo[]
     */
    public function alertsDeleteGet($id)
    {
        list($response) = $this->alertsDeleteGetWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation alertsDeleteGetWithHttpInfo
     *
     * Permanently delete the alert
     *
     * @param  string $id alert id to delete (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\TransactionInfo[], HTTP status code, HTTP response headers (array of strings)
     */
    public function alertsDeleteGetWithHttpInfo($id)
    {
        $returnType = '\Swagger\Client\Model\TransactionInfo[]';
        $request = $this->alertsDeleteGetRequest($id);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\TransactionInfo[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation alertsDeleteGetAsync
     *
     * Permanently delete the alert
     *
     * @param  string $id alert id to delete (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsDeleteGetAsync($id)
    {
        return $this->alertsDeleteGetAsyncWithHttpInfo($id)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation alertsDeleteGetAsyncWithHttpInfo
     *
     * Permanently delete the alert
     *
     * @param  string $id alert id to delete (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsDeleteGetAsyncWithHttpInfo($id)
    {
        $returnType = '\Swagger\Client\Model\TransactionInfo[]';
        $request = $this->alertsDeleteGetRequest($id);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'alertsDeleteGet'
     *
     * @param  string $id alert id to delete (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function alertsDeleteGetRequest($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling alertsDeleteGet'
            );
        }

        $resourcePath = '/alerts_delete';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($id !== null) {
            $queryParams['id'] = ObjectSerializer::toQueryValue($id, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation alertsGet
     *
     * Get alerts for user account
     *
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Alerts[]
     */
    public function alertsGet()
    {
        list($response) = $this->alertsGetWithHttpInfo();
        return $response;
    }

    /**
     * Operation alertsGetWithHttpInfo
     *
     * Get alerts for user account
     *
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Alerts[], HTTP status code, HTTP response headers (array of strings)
     */
    public function alertsGetWithHttpInfo()
    {
        $returnType = '\Swagger\Client\Model\Alerts[]';
        $request = $this->alertsGetRequest();

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Alerts[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation alertsGetAsync
     *
     * Get alerts for user account
     *
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsGetAsync()
    {
        return $this->alertsGetAsyncWithHttpInfo()
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation alertsGetAsyncWithHttpInfo
     *
     * Get alerts for user account
     *
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function alertsGetAsyncWithHttpInfo()
    {
        $returnType = '\Swagger\Client\Model\Alerts[]';
        $request = $this->alertsGetRequest();

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'alertsGet'
     *
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function alertsGetRequest()
    {

        $resourcePath = '/alerts';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
