<?php
/**
 * HistoricalApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.67
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * HistoricalApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class HistoricalApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation categoriesGet
     *
     * Get historical stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to cateogry names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Categories[]
     */
    public function categoriesGet($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->categoriesGetWithHttpInfo($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation categoriesGetWithHttpInfo
     *
     * Get historical stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to cateogry names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Categories[], HTTP status code, HTTP response headers (array of strings)
     */
    public function categoriesGetWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Categories[]';
        $request = $this->categoriesGetRequest($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Categories[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation categoriesGetAsync
     *
     * Get historical stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to cateogry names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function categoriesGetAsync($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        return $this->categoriesGetAsyncWithHttpInfo($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation categoriesGetAsyncWithHttpInfo
     *
     * Get historical stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to cateogry names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function categoriesGetAsyncWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Categories[]';
        $request = $this->categoriesGetRequest($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'categoriesGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to cateogry names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function categoriesGetRequest($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling categoriesGet'
            );
        }

        $resourcePath = '/categories';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation categoryGet
     *
     * Get history for category ID
     *
     * @param  string $id category id (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Category[]
     */
    public function categoryGet($id, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        list($response) = $this->categoryGetWithHttpInfo($id, $country, $subcountry, $from_date, $to_date);
        return $response;
    }

    /**
     * Operation categoryGetWithHttpInfo
     *
     * Get history for category ID
     *
     * @param  string $id category id (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Category[], HTTP status code, HTTP response headers (array of strings)
     */
    public function categoryGetWithHttpInfo($id, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Category[]';
        $request = $this->categoryGetRequest($id, $country, $subcountry, $from_date, $to_date);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Category[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation categoryGetAsync
     *
     * Get history for category ID
     *
     * @param  string $id category id (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function categoryGetAsync($id, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        return $this->categoryGetAsyncWithHttpInfo($id, $country, $subcountry, $from_date, $to_date)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation categoryGetAsyncWithHttpInfo
     *
     * Get history for category ID
     *
     * @param  string $id category id (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function categoryGetAsyncWithHttpInfo($id, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Category[]';
        $request = $this->categoryGetRequest($id, $country, $subcountry, $from_date, $to_date);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'categoryGet'
     *
     * @param  string $id category id (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function categoryGetRequest($id, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling categoryGet'
            );
        }
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling categoryGet'
            );
        }

        $resourcePath = '/category';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($id !== null) {
            $queryParams['id'] = ObjectSerializer::toQueryValue($id, null);
        }
        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation domainGet
     *
     * Get history for domain name
     *
     * @param  string $domain domain name (no subdomain allowed) (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Domain[]
     */
    public function domainGet($domain, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        list($response) = $this->domainGetWithHttpInfo($domain, $country, $subcountry, $from_date, $to_date);
        return $response;
    }

    /**
     * Operation domainGetWithHttpInfo
     *
     * Get history for domain name
     *
     * @param  string $domain domain name (no subdomain allowed) (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Domain[], HTTP status code, HTTP response headers (array of strings)
     */
    public function domainGetWithHttpInfo($domain, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Domain[]';
        $request = $this->domainGetRequest($domain, $country, $subcountry, $from_date, $to_date);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Domain[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation domainGetAsync
     *
     * Get history for domain name
     *
     * @param  string $domain domain name (no subdomain allowed) (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function domainGetAsync($domain, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        return $this->domainGetAsyncWithHttpInfo($domain, $country, $subcountry, $from_date, $to_date)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation domainGetAsyncWithHttpInfo
     *
     * Get history for domain name
     *
     * @param  string $domain domain name (no subdomain allowed) (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function domainGetAsyncWithHttpInfo($domain, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Domain[]';
        $request = $this->domainGetRequest($domain, $country, $subcountry, $from_date, $to_date);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'domainGet'
     *
     * @param  string $domain domain name (no subdomain allowed) (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function domainGetRequest($domain, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        // verify the required parameter 'domain' is set
        if ($domain === null || (is_array($domain) && count($domain) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $domain when calling domainGet'
            );
        }
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling domainGet'
            );
        }

        $resourcePath = '/domain';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($domain !== null) {
            $queryParams['domain'] = ObjectSerializer::toQueryValue($domain, null);
        }
        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation domainsGet
     *
     * Get historical stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Domains[]
     */
    public function domainsGet($country, $subcountry = null, $from_date = null, $to_date = null, $url_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->domainsGetWithHttpInfo($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation domainsGetWithHttpInfo
     *
     * Get historical stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Domains[], HTTP status code, HTTP response headers (array of strings)
     */
    public function domainsGetWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $url_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->domainsGetRequest($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Domains[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation domainsGetAsync
     *
     * Get historical stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function domainsGetAsync($country, $subcountry = null, $from_date = null, $to_date = null, $url_filter = null, $lines = '50', $offset = '0')
    {
        return $this->domainsGetAsyncWithHttpInfo($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation domainsGetAsyncWithHttpInfo
     *
     * Get historical stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function domainsGetAsyncWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $url_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->domainsGetRequest($country, $subcountry, $from_date, $to_date, $url_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'domainsGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function domainsGetRequest($country, $subcountry = null, $from_date = null, $to_date = null, $url_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling domainsGet'
            );
        }

        $resourcePath = '/domains';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }
        // query params
        if ($url_filter !== null) {
            $queryParams['url_filter'] = ObjectSerializer::toQueryValue($url_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation entitiesGet
     *
     * Get historical stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Entities[]
     */
    public function entitiesGet($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->entitiesGetWithHttpInfo($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation entitiesGetWithHttpInfo
     *
     * Get historical stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Entities[], HTTP status code, HTTP response headers (array of strings)
     */
    public function entitiesGetWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Entities[]';
        $request = $this->entitiesGetRequest($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Entities[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation entitiesGetAsync
     *
     * Get historical stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function entitiesGetAsync($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        return $this->entitiesGetAsyncWithHttpInfo($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation entitiesGetAsyncWithHttpInfo
     *
     * Get historical stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function entitiesGetAsyncWithHttpInfo($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Entities[]';
        $request = $this->entitiesGetRequest($country, $subcountry, $from_date, $to_date, $keyword_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'entitiesGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function entitiesGetRequest($country, $subcountry = null, $from_date = null, $to_date = null, $keyword_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling entitiesGet'
            );
        }

        $resourcePath = '/entities';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation entityGet
     *
     * Get history for entity
     *
     * @param  string $name entity exact name URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Entity[]
     */
    public function entityGet($name, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        list($response) = $this->entityGetWithHttpInfo($name, $country, $subcountry, $from_date, $to_date);
        return $response;
    }

    /**
     * Operation entityGetWithHttpInfo
     *
     * Get history for entity
     *
     * @param  string $name entity exact name URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Entity[], HTTP status code, HTTP response headers (array of strings)
     */
    public function entityGetWithHttpInfo($name, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Entity[]';
        $request = $this->entityGetRequest($name, $country, $subcountry, $from_date, $to_date);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Entity[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation entityGetAsync
     *
     * Get history for entity
     *
     * @param  string $name entity exact name URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function entityGetAsync($name, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        return $this->entityGetAsyncWithHttpInfo($name, $country, $subcountry, $from_date, $to_date)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation entityGetAsyncWithHttpInfo
     *
     * Get history for entity
     *
     * @param  string $name entity exact name URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function entityGetAsyncWithHttpInfo($name, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Entity[]';
        $request = $this->entityGetRequest($name, $country, $subcountry, $from_date, $to_date);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'entityGet'
     *
     * @param  string $name entity exact name URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function entityGetRequest($name, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        // verify the required parameter 'name' is set
        if ($name === null || (is_array($name) && count($name) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $name when calling entityGet'
            );
        }
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling entityGet'
            );
        }

        $resourcePath = '/entity';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($name !== null) {
            $queryParams['name'] = ObjectSerializer::toQueryValue($name, null);
        }
        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation pageGet
     *
     * Get page history for URL
     *
     * @param  string $url Fully qualified page url. URL needs to be URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Page[]
     */
    public function pageGet($url, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        list($response) = $this->pageGetWithHttpInfo($url, $country, $subcountry, $from_date, $to_date);
        return $response;
    }

    /**
     * Operation pageGetWithHttpInfo
     *
     * Get page history for URL
     *
     * @param  string $url Fully qualified page url. URL needs to be URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Page[], HTTP status code, HTTP response headers (array of strings)
     */
    public function pageGetWithHttpInfo($url, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Page[]';
        $request = $this->pageGetRequest($url, $country, $subcountry, $from_date, $to_date);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Page[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation pageGetAsync
     *
     * Get page history for URL
     *
     * @param  string $url Fully qualified page url. URL needs to be URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pageGetAsync($url, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        return $this->pageGetAsyncWithHttpInfo($url, $country, $subcountry, $from_date, $to_date)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation pageGetAsyncWithHttpInfo
     *
     * Get page history for URL
     *
     * @param  string $url Fully qualified page url. URL needs to be URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pageGetAsyncWithHttpInfo($url, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        $returnType = '\Swagger\Client\Model\Page[]';
        $request = $this->pageGetRequest($url, $country, $subcountry, $from_date, $to_date);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'pageGet'
     *
     * @param  string $url Fully qualified page url. URL needs to be URL encoded (required)
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function pageGetRequest($url, $country, $subcountry = null, $from_date = null, $to_date = null)
    {
        // verify the required parameter 'url' is set
        if ($url === null || (is_array($url) && count($url) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $url when calling pageGet'
            );
        }
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling pageGet'
            );
        }

        $resourcePath = '/page';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($url !== null) {
            $queryParams['url'] = ObjectSerializer::toQueryValue($url, null);
        }
        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation pagesGet
     *
     * Get historical stats for pages
     *
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param  string $subcountry state code (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to a specific page category (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Pages[]
     */
    public function pagesGet($from_date = null, $to_date = null, $country = null, $subcountry = null, $preset_filter = null, $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->pagesGetWithHttpInfo($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation pagesGetWithHttpInfo
     *
     * Get historical stats for pages
     *
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param  string $subcountry state code (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to a specific page category (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Pages[], HTTP status code, HTTP response headers (array of strings)
     */
    public function pagesGetWithHttpInfo($from_date = null, $to_date = null, $country = null, $subcountry = null, $preset_filter = null, $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Pages[]';
        $request = $this->pagesGetRequest($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Pages[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation pagesGetAsync
     *
     * Get historical stats for pages
     *
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param  string $subcountry state code (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to a specific page category (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pagesGetAsync($from_date = null, $to_date = null, $country = null, $subcountry = null, $preset_filter = null, $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        return $this->pagesGetAsyncWithHttpInfo($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation pagesGetAsyncWithHttpInfo
     *
     * Get historical stats for pages
     *
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param  string $subcountry state code (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to a specific page category (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pagesGetAsyncWithHttpInfo($from_date = null, $to_date = null, $country = null, $subcountry = null, $preset_filter = null, $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Pages[]';
        $request = $this->pagesGetRequest($from_date, $to_date, $country, $subcountry, $preset_filter, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'pagesGet'
     *
     * @param  string $from_date Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $to_date Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param  string $country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param  string $subcountry state code (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to a specific page category (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function pagesGetRequest($from_date = null, $to_date = null, $country = null, $subcountry = null, $preset_filter = null, $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {

        $resourcePath = '/pages';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date, null);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date, null);
        }
        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($preset_filter !== null) {
            $queryParams['preset_filter'] = ObjectSerializer::toQueryValue($preset_filter, null);
        }
        // query params
        if ($domain_filter !== null) {
            $queryParams['domain_filter'] = ObjectSerializer::toQueryValue($domain_filter, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($entity_filter !== null) {
            $queryParams['entity_filter'] = ObjectSerializer::toQueryValue($entity_filter, null);
        }
        // query params
        if ($url_filter !== null) {
            $queryParams['url_filter'] = ObjectSerializer::toQueryValue($url_filter, null);
        }
        // query params
        if ($category_filter !== null) {
            $queryParams['category_filter'] = ObjectSerializer::toQueryValue($category_filter, null);
        }
        // query params
        if ($language_filter !== null) {
            $queryParams['language_filter'] = ObjectSerializer::toQueryValue($language_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
