<?php
/**
 * LiveApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.67
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * LiveApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class LiveApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation livecategoriesGet
     *
     * Get livedata stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to category names containing a particular keyword (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Categories[]
     */
    public function livecategoriesGet($country, $subcountry = null, $hours = null, $keyword_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->livecategoriesGetWithHttpInfo($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation livecategoriesGetWithHttpInfo
     *
     * Get livedata stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to category names containing a particular keyword (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Categories[], HTTP status code, HTTP response headers (array of strings)
     */
    public function livecategoriesGetWithHttpInfo($country, $subcountry = null, $hours = null, $keyword_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Categories[]';
        $request = $this->livecategoriesGetRequest($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Categories[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation livecategoriesGetAsync
     *
     * Get livedata stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to category names containing a particular keyword (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livecategoriesGetAsync($country, $subcountry = null, $hours = null, $keyword_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        return $this->livecategoriesGetAsyncWithHttpInfo($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation livecategoriesGetAsyncWithHttpInfo
     *
     * Get livedata stats for categories
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to category names containing a particular keyword (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livecategoriesGetAsyncWithHttpInfo($country, $subcountry = null, $hours = null, $keyword_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Categories[]';
        $request = $this->livecategoriesGetRequest($country, $subcountry, $hours, $keyword_filter, $language_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'livecategoriesGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to category names containing a particular keyword (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function livecategoriesGetRequest($country, $subcountry = null, $hours = null, $keyword_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling livecategoriesGet'
            );
        }

        $resourcePath = '/livecategories';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($hours !== null) {
            $queryParams['hours'] = ObjectSerializer::toQueryValue($hours, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($language_filter !== null) {
            $queryParams['language_filter'] = ObjectSerializer::toQueryValue($language_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation livedomainsGet
     *
     * Get livedata stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Domains[]
     */
    public function livedomainsGet($country, $subcountry = null, $url_filter = null, $hours = null, $lines = '50', $language_filter = null, $offset = '0')
    {
        list($response) = $this->livedomainsGetWithHttpInfo($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset);
        return $response;
    }

    /**
     * Operation livedomainsGetWithHttpInfo
     *
     * Get livedata stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Domains[], HTTP status code, HTTP response headers (array of strings)
     */
    public function livedomainsGetWithHttpInfo($country, $subcountry = null, $url_filter = null, $hours = null, $lines = '50', $language_filter = null, $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->livedomainsGetRequest($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Domains[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation livedomainsGetAsync
     *
     * Get livedata stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livedomainsGetAsync($country, $subcountry = null, $url_filter = null, $hours = null, $lines = '50', $language_filter = null, $offset = '0')
    {
        return $this->livedomainsGetAsyncWithHttpInfo($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation livedomainsGetAsyncWithHttpInfo
     *
     * Get livedata stats for domains
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livedomainsGetAsyncWithHttpInfo($country, $subcountry = null, $url_filter = null, $hours = null, $lines = '50', $language_filter = null, $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Domains[]';
        $request = $this->livedomainsGetRequest($country, $subcountry, $url_filter, $hours, $lines, $language_filter, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'livedomainsGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  string $url_filter Filter answers to domains including a specified string (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function livedomainsGetRequest($country, $subcountry = null, $url_filter = null, $hours = null, $lines = '50', $language_filter = null, $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling livedomainsGet'
            );
        }

        $resourcePath = '/livedomains';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($url_filter !== null) {
            $queryParams['url_filter'] = ObjectSerializer::toQueryValue($url_filter, null);
        }
        // query params
        if ($hours !== null) {
            $queryParams['hours'] = ObjectSerializer::toQueryValue($hours, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($language_filter !== null) {
            $queryParams['language_filter'] = ObjectSerializer::toQueryValue($language_filter, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation liveentitiesGet
     *
     * Get livedata stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Entities[]
     */
    public function liveentitiesGet($country, $subcountry = null, $hours = null, $keyword_filter = null, $category_filter = null, $language_filter = null, $domain_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->liveentitiesGetWithHttpInfo($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation liveentitiesGetWithHttpInfo
     *
     * Get livedata stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Entities[], HTTP status code, HTTP response headers (array of strings)
     */
    public function liveentitiesGetWithHttpInfo($country, $subcountry = null, $hours = null, $keyword_filter = null, $category_filter = null, $language_filter = null, $domain_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Entities[]';
        $request = $this->liveentitiesGetRequest($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Entities[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation liveentitiesGetAsync
     *
     * Get livedata stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function liveentitiesGetAsync($country, $subcountry = null, $hours = null, $keyword_filter = null, $category_filter = null, $language_filter = null, $domain_filter = null, $lines = '50', $offset = '0')
    {
        return $this->liveentitiesGetAsyncWithHttpInfo($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation liveentitiesGetAsyncWithHttpInfo
     *
     * Get livedata stats for entities
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function liveentitiesGetAsyncWithHttpInfo($country, $subcountry = null, $hours = null, $keyword_filter = null, $category_filter = null, $language_filter = null, $domain_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Entities[]';
        $request = $this->liveentitiesGetRequest($country, $subcountry, $hours, $keyword_filter, $category_filter, $language_filter, $domain_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'liveentitiesGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  string $keyword_filter Filter answers to entity names containing a particular keyword (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function liveentitiesGetRequest($country, $subcountry = null, $hours = null, $keyword_filter = null, $category_filter = null, $language_filter = null, $domain_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling liveentitiesGet'
            );
        }

        $resourcePath = '/liveentities';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($hours !== null) {
            $queryParams['hours'] = ObjectSerializer::toQueryValue($hours, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($category_filter !== null) {
            $queryParams['category_filter'] = ObjectSerializer::toQueryValue($category_filter, null);
        }
        // query params
        if ($language_filter !== null) {
            $queryParams['language_filter'] = ObjectSerializer::toQueryValue($language_filter, null);
        }
        // query params
        if ($domain_filter !== null) {
            $queryParams['domain_filter'] = ObjectSerializer::toQueryValue($domain_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation livepagesGet
     *
     * Get livedata stats for pages
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)
     * @param  int $only_new Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Pages[]
     */
    public function livepagesGet($country, $subcountry = null, $hours = null, $preset_filter = null, $only_new = '0', $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        list($response) = $this->livepagesGetWithHttpInfo($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);
        return $response;
    }

    /**
     * Operation livepagesGetWithHttpInfo
     *
     * Get livedata stats for pages
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)
     * @param  int $only_new Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Pages[], HTTP status code, HTTP response headers (array of strings)
     */
    public function livepagesGetWithHttpInfo($country, $subcountry = null, $hours = null, $preset_filter = null, $only_new = '0', $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Pages[]';
        $request = $this->livepagesGetRequest($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Pages[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation livepagesGetAsync
     *
     * Get livedata stats for pages
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)
     * @param  int $only_new Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livepagesGetAsync($country, $subcountry = null, $hours = null, $preset_filter = null, $only_new = '0', $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        return $this->livepagesGetAsyncWithHttpInfo($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation livepagesGetAsyncWithHttpInfo
     *
     * Get livedata stats for pages
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)
     * @param  int $only_new Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function livepagesGetAsyncWithHttpInfo($country, $subcountry = null, $hours = null, $preset_filter = null, $only_new = '0', $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        $returnType = '\Swagger\Client\Model\Pages[]';
        $request = $this->livepagesGetRequest($country, $subcountry, $hours, $preset_filter, $only_new, $domain_filter, $keyword_filter, $entity_filter, $url_filter, $category_filter, $language_filter, $lines, $offset);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'livepagesGet'
     *
     * @param  string $country ISO_3166 country code in 2 letters (required)
     * @param  string $subcountry state code (optional)
     * @param  int $hours Get results for last x hours (optional)
     * @param  int $preset_filter Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)
     * @param  int $only_new Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param  string $domain_filter Filter answers to pages of a designated domain name (optional)
     * @param  string $keyword_filter Filter answers to pages titles containing a particular keyword (optional)
     * @param  string $entity_filter Filter answers to pages with entities containing a particular keyword (optional)
     * @param  string $url_filter Filter answers to pages URL including a specified string (optional)
     * @param  int $category_filter Filter answers to pages of a designated category id (optional)
     * @param  string $language_filter Filter answers to pages in specific user language (optional)
     * @param  int $lines Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)
     * @param  int $offset Get paginated results from X offset (optional, default to 0)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function livepagesGetRequest($country, $subcountry = null, $hours = null, $preset_filter = null, $only_new = '0', $domain_filter = null, $keyword_filter = null, $entity_filter = null, $url_filter = null, $category_filter = null, $language_filter = null, $lines = '50', $offset = '0')
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling livepagesGet'
            );
        }

        $resourcePath = '/livepages';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($subcountry !== null) {
            $queryParams['subcountry'] = ObjectSerializer::toQueryValue($subcountry, null);
        }
        // query params
        if ($hours !== null) {
            $queryParams['hours'] = ObjectSerializer::toQueryValue($hours, null);
        }
        // query params
        if ($preset_filter !== null) {
            $queryParams['preset_filter'] = ObjectSerializer::toQueryValue($preset_filter, null);
        }
        // query params
        if ($only_new !== null) {
            $queryParams['only_new'] = ObjectSerializer::toQueryValue($only_new, null);
        }
        // query params
        if ($domain_filter !== null) {
            $queryParams['domain_filter'] = ObjectSerializer::toQueryValue($domain_filter, null);
        }
        // query params
        if ($keyword_filter !== null) {
            $queryParams['keyword_filter'] = ObjectSerializer::toQueryValue($keyword_filter, null);
        }
        // query params
        if ($entity_filter !== null) {
            $queryParams['entity_filter'] = ObjectSerializer::toQueryValue($entity_filter, null);
        }
        // query params
        if ($url_filter !== null) {
            $queryParams['url_filter'] = ObjectSerializer::toQueryValue($url_filter, null);
        }
        // query params
        if ($category_filter !== null) {
            $queryParams['category_filter'] = ObjectSerializer::toQueryValue($category_filter, null);
        }
        // query params
        if ($language_filter !== null) {
            $queryParams['language_filter'] = ObjectSerializer::toQueryValue($language_filter, null);
        }
        // query params
        if ($lines !== null) {
            $queryParams['lines'] = ObjectSerializer::toQueryValue($lines, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

            // // this endpoint requires Bearer token
            if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
            }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
